diff -urN dpkg-1.10.21.orig/main/main.c dpkg-1.10.21/main/main.c
--- dpkg-1.10.21.orig/main/main.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/main.c	2012-07-13 02:13:27.000000000 +0200
@@ -38,6 +38,12 @@
 #include <version.h>
 #include <myopt.h>
 
+/* FINK LOCAL begin */
+#include <sys/utsname.h>
+#include <CoreFoundation/CoreFoundation.h>
+static void finkinit();
+/* FINK LOCAL end */
+
 #include "main.h"
 
 static void printversion(void) {
@@ -546,6 +552,153 @@
   }
 }
 
+/* FINK LOCAL begin */
+struct FinkVirtualPkgs {
+  struct FinkVirtualPkgs *next;
+  char *pkgname;
+  struct versionrevision version;
+};
+
+struct FinkVirtualPkgs *fink_virt_pkg = NULL;
+static void finkinit()
+{
+	FILE *virt_pkg_stream = NULL;
+	struct stat sb;
+	struct FinkVirtualPkgs *pkg;
+	char name[256];
+	char version[256];
+	char revision[256];
+	unsigned int  epoch;
+    Boolean status;
+    SInt32 errorCode;
+    CFURLRef fileURL = NULL;
+    CFDataRef resourceData = NULL;
+    CFPropertyListRef propertyList = NULL;
+    CFStringRef string;
+    static char buffer[256];	// This is static, to ensure the buffer stays around
+
+    static struct utsname ver;	// This is static, to ensure the buffer stays around
+	if (0 == stat("@PREFIX@/bin/fink-virtual-pkgs", &sb))
+	{
+	  virt_pkg_stream =popen("@PREFIX@/bin/fink-virtual-pkgs --dpkg","r");
+  	  if (virt_pkg_stream)
+	  {
+	    while (fscanf(virt_pkg_stream,"%s\t%u\t%s\t%s\n",name,&epoch,version, revision) == 4)
+	    {
+	      pkg = (struct FinkVirtualPkgs *)malloc(sizeof(struct FinkVirtualPkgs));
+	      if (pkg)
+	      {
+			  pkg->next = fink_virt_pkg;
+			  pkg->pkgname = strdup(name);
+			  pkg->version.epoch = epoch;
+			  pkg->version.version = strdup(version);
+			  pkg->version.revision = strdup(revision);
+			  /* Quick and simple sanity check */
+			  if ((NULL != pkg->pkgname) && (0 != strlen(pkg->pkgname)) &&
+			      (NULL != pkg->version.version) && (0 != strlen(pkg->version.version)) &&
+			      (NULL != pkg->version.revision) && (0 != strlen(pkg->version.revision)))
+			  {
+			  	/* We are leaking here if something fails the sanity check above */
+			  	fink_virt_pkg = pkg;
+			  }
+	      }
+	    }
+	    if (pclose(virt_pkg_stream))
+	    {
+	    	/* The fink-virtual-pkgs script returned a non zero exit status *
+	    	 * clean up and try the old way.                                */
+	    	while(NULL != fink_virt_pkg)
+	    	{
+	    		pkg = fink_virt_pkg;
+	    		if (NULL != pkg->pkgname) free(pkg->pkgname);
+	    		if (NULL != pkg->version.version) free(pkg->version.version);
+	    		if (NULL != pkg->version.revision) free(pkg->version.revision);
+	    		fink_virt_pkg = pkg->next;
+	    		free(pkg);
+	    	}
+                fink_virt_pkg = NULL;
+	    }
+	  }
+	} 
+	if (NULL == fink_virt_pkg)
+	{
+	  /* Determine system version */
+	  /* TODO - should maybe check if this is really Darwin? */
+	  if (!uname(&ver)) {
+	      pkg = (struct FinkVirtualPkgs *)malloc(sizeof(struct FinkVirtualPkgs));
+	      if (pkg) {
+			  pkg->next = fink_virt_pkg;
+			  pkg->pkgname = strdup("darwin");
+			  pkg->version.epoch = 0;
+			  pkg->version.version = ver.release;
+			  pkg->version.revision = NULL;
+			  fink_virt_pkg = pkg;
+	      }  
+	  }
+	
+	  /* Check whether this is Mac OS X, and which version of it */
+
+	  fileURL = CFURLCreateWithFileSystemPath( NULL, 	
+			CFSTR("/System/Library/CoreServices/SystemVersion.plist"),
+			kCFURLPOSIXPathStyle,				
+			false );
+	  if (!fileURL)
+		goto BAIL;
+	  
+	  /* Read the XML */
+	  status = CFURLCreateDataAndPropertiesFromResource(
+			NULL,
+			fileURL,
+			&resourceData,
+			NULL,		
+			NULL,
+			&errorCode);
+	  if (!status || errorCode != 0)
+		goto BAIL;
+	  
+	  /* Reconstitute the dictionary using the XML data. */
+	  propertyList = CFPropertyListCreateFromXMLData( NULL,
+			resourceData,
+			kCFPropertyListImmutable,
+			&string);
+	  if (!propertyList)
+		goto BAIL;
+	  
+	  /* Try to read the system version from it. */
+	  status = CFDictionaryGetValueIfPresent( propertyList,
+			CFSTR("ProductVersion"),
+			(void*)&string);
+	  if (!status)
+		goto BAIL;
+	  
+	  /* Convert into a C string */
+	  status = CFStringGetCString( string,
+			buffer,
+			sizeof(buffer),
+			kCFStringEncodingISOLatin1);
+	  if (!status)
+		goto BAIL;
+	  pkg = (struct FinkVirtualPkgs *)malloc(sizeof(struct FinkVirtualPkgs));
+	  if (pkg)
+	  {
+		  pkg->next = fink_virt_pkg;
+		  pkg->pkgname = strdup("macosx");
+		  pkg->version.epoch = 0;
+		  pkg->version.version = buffer;
+		  pkg->version.revision = NULL;
+		  fink_virt_pkg = pkg;
+	  }
+	BAIL:
+	  // Release all of the CF objects we're responsible for.
+	  if (fileURL)
+		CFRelease(fileURL);
+	  if (resourceData)
+		CFRelease(resourceData);
+	  if (propertyList)
+		CFRelease(propertyList);
+	}
+}
+/* FINK LOCAL end */
 
 int main(int argc, const char *const *argv) {
   jmp_buf ejbuf;
@@ -556,7 +709,9 @@
 
   setvbuf(stdout,0,_IONBF,0);
   filesdbinit();
-
+  /* FINK LOCAL begin */
+  finkinit();
+  /* FINK LOCAL end */
   actionfunction= (void (*)(const char* const*))cipaction->farg;
 
   actionfunction(argv);
diff -urN dpkg-1.10.21.orig/main/main.h dpkg-1.10.21/main/main.h
--- dpkg-1.10.21.orig/main/main.h	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/main.h	2012-07-13 02:13:27.000000000 +0200
@@ -93,6 +93,11 @@
 extern const char *instdir;
 extern struct packageinlist *ignoredependss;
 extern const char architecture[];
+ 
+/* FINK LOCAL begin */
+extern struct versionrevision darwin_version;
+extern struct versionrevision macosx_version;
+/* FINK LOCAL end */
 
 /* from filesdb.c */
 
diff -urN dpkg-1.10.21.orig/main/packages.c dpkg-1.10.21/main/packages.c
--- dpkg-1.10.21.orig/main/packages.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/packages.c	2012-07-13 02:13:27.000000000 +0200
@@ -331,6 +331,30 @@
     return thisf;
   }
 }
+ 
+/* FINK LOCAL begin */
+static int check_pseudo_package(const struct versionrevision *versrev, const struct deppossi *possi,
+                                int *interestingwarnings, struct varbuf *oemsgs) {
+
+  if (versionsatisfied3(versrev,&possi->version,possi->verrel)) {
+    return 3;
+  } else {
+    varbufaddstr(oemsgs, _("  Version of "));
+    varbufaddstr(oemsgs, possi->ed->name);
+    varbufaddstr(oemsgs, _(" on system is "));
+    varbufaddstr(oemsgs, versiondescribe(versrev, vdew_nonambig));
+    varbufaddstr(oemsgs, ".\n");
+    (*interestingwarnings)++;
+    return 0;
+  }
+}
+struct FinkVirtualPkgs {
+  struct FinkVirtualPkgs *next;
+  char *pkgname;
+  struct versionrevision version;
+};
+extern struct FinkVirtualPkgs *fink_virt_pkg;
+/* FINK LOCAL end */
 
 int dependencies_ok(struct pkginfo *pkg, struct pkginfo *removing,
                     struct varbuf *aemsgs) {
@@ -338,7 +362,7 @@
   struct varbuf oemsgs;
   struct dependency *dep;
   struct deppossi *possi, *provider;
-
+  struct FinkVirtualPkgs *virt_pkg = NULL; 
   varbufinit(&oemsgs);
   interestingwarnings= 0;
   ok= 2; /* 2=ok, 1=defer, 0=halt */
@@ -352,6 +376,29 @@
     found= 0; /* 0=none, 1=defer, 2=withwarning, 3=ok */
     for (possi= dep->list; found != 3 && possi; possi= possi->next) {
       debug(dbg_depcondetail,"    checking possibility  -> %s",possi->ed->name);
+      /* FINK LOCAL begin */
+      virt_pkg = fink_virt_pkg;
+      while (virt_pkg)
+      {
+        if (0==strcmp(possi->ed->name,virt_pkg->pkgname)) {
+          debug(dbg_depcondetail,"        pseudo package");
+          found= check_pseudo_package(&virt_pkg->version,possi,&interestingwarnings,&oemsgs);
+        }
+        virt_pkg = virt_pkg->next;
+      }
+/*      
+      if (0==strcmp(possi->ed->name,"darwin") && darwin_version.version) {
+        debug(dbg_depcondetail,"        pseudo package darwin");
+        found= check_pseudo_package(&darwin_version,possi,&interestingwarnings,&oemsgs);
+        break;
+      }
+      else if (0==strcmp(possi->ed->name,"macosx") && macosx_version.version) {
+        debug(dbg_depcondetail,"        pseudo package macosx");
+        found= check_pseudo_package(&macosx_version,possi,&interestingwarnings,&oemsgs);
+        break;
+      }
+*/      
+      /* FINK LOCAL end */
       if (possi->cyclebreak) {
         debug(dbg_depcondetail,"      break cycle so ok and found");
         found= 3; break;
diff -urN dpkg-1.10.21.orig/origin.fink dpkg-1.10.21/origin.fink
--- dpkg-1.10.21.orig/origin.fink	1970-01-01 01:00:00.000000000 +0100
+++ dpkg-1.10.21/origin.fink	2012-07-13 02:13:27.000000000 +0200
@@ -0,0 +1,3 @@
+Vendor: Fink
+Vendor-URL: http://fink.sourceforge.net/
+Bugs: http://fink.sourceforge.net/
diff -urN dpkg-1.10.21.orig/scripts/dpkg-name.sh dpkg-1.10.21/scripts/dpkg-name.sh
--- dpkg-1.10.21.orig/scripts/dpkg-name.sh	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/scripts/dpkg-name.sh	2012-07-13 02:13:27.000000000 +0200
@@ -10,6 +10,7 @@
 license () {
 echo "# ${prog} ${version} -- ${purpose}
 # Copyright (C) 1995,1996 Erick Branderhorst <branderh@debian.org>.
+# Paths modified by Carsten Klapp to reflect fink distribution, December 2002.
 
 # This is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
@@ -19,7 +20,7 @@
 # This is distributed in the hope that it will be useful, but
 # WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the file
-# /usr/share/common-licenses/GPL for more details."
+# @PREFIX@/share/common-licenses/GPL for more details."
 }
 
 stderr () {
diff -urN dpkg-1.10.21.orig/scripts/install-info.pl dpkg-1.10.21/scripts/install-info.pl
--- dpkg-1.10.21.orig/scripts/install-info.pl	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/scripts/install-info.pl	2012-07-13 02:13:27.000000000 +0200
@@ -29,11 +29,11 @@
 END
 }
 
-$infodir='/usr/share/info';
+$infodir='@PREFIX@/share/info';
 $maxwidth=79;
 $Text::Wrap::columns=$maxwidth;
-$backup='/var/backups/infodir.bak';
-$default='/usr/share/base-files/info.dir';
+$backup='@PREFIX@/share/info/dir.bak';
+$default='@PREFIX@/share/base-files/dir-base';
 
 $menuentry="";
 $description="";
diff -urN dpkg-1.10.21.orig/scripts/update-alternatives.pl dpkg-1.10.21/scripts/update-alternatives.pl
--- dpkg-1.10.21.orig/scripts/update-alternatives.pl	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/scripts/update-alternatives.pl	2012-07-13 02:13:27.000000000 +0200
@@ -59,7 +59,7 @@
 sub quit { print STDERR "update-alternatives: @_\n"; exit(2); }
 sub badusage { print STDERR "update-alternatives: @_\n\n"; &usageversion; exit(2); }
 
-$altdir= '/etc/alternatives';
+$altdir= '@PREFIX@/etc/alternatives';
 $admindir= $admindir . '/alternatives';
 $testmode= 0;
 $verbosemode= 0;
diff -Nurd dpkg-1.10.21/include/dpkg.h.in dpkg-1.10.21.patched/include/dpkg.h.in
--- dpkg-1.10.21/include/dpkg.h.in	2004-04-24 14:14:21.000000000 -0700
+++ dpkg-1.10.21.patched/include/dpkg.h.in	2013-11-10 18:04:41.000000000 -0800
@@ -148,6 +148,7 @@
   setlocale(LC_ALL, "");\
   bindtextdomain(PACKAGE, LOCALEDIR);\
   textdomain(PACKAGE);\
+  gettext("");\
   if (setjmp(*ejbuf)) { /* expect warning about possible clobbering of argv */\
     error_unwind(ehflag_bombout); exit(2);\
   }\
